#
# Conditional build:
%bcond_without	python	# Python bindings for libbtrfsutil
%bcond_without	tests	# libbtrfsutil tests (requires python)

%if %{without python}
%undefine	with_tests
%endif
Summary:	Utilities belonging to the btrfs filesystem
Summary(pl.UTF-8):	Narzędzia należące do systemu plików btrfs
Name:		btrfs-progs
Version:	5.11.1
Release:	1
License:	GPL v2
Group:		Applications/System
Source0:	https://www.kernel.org/pub/linux/kernel/people/kdave/btrfs-progs/%{name}-v%{version}.tar.xz
# Source0-md5:	7a8d0201da222c838a89fb31511f8d86
Patch0:		%{name}-sh.patch
URL:		http://btrfs.wiki.kernel.org/
BuildRequires:	acl-devel
BuildRequires:	asciidoc
BuildRequires:	autoconf >= 2.60
BuildRequires:	automake
BuildRequires:	e2fsprogs-devel >= 1.42.0
BuildRequires:	libblkid-devel
BuildRequires:	libcom_err-devel
BuildRequires:	libuuid-devel
BuildRequires:	lzo-devel >= 2
BuildRequires:	pkgconfig >= 0.9.0
%{?with_python:BuildRequires:	python3-devel >= 1:3.4}
%{?with_python:BuildRequires:	python3-setuptools}
BuildRequires:	reiserfsprogs-devel >= 3.6.27
BuildRequires:	tar >= 1:1.22
BuildRequires:	udev-devel >= 1:190
BuildRequires:	xmlto
BuildRequires:	xz
BuildRequires:	zlib-devel
BuildRequires:	zstd-devel >= 1.0.0
Requires:	e2fsprogs-libs >= 1.42.0
Requires:	reiserfsprogs-libs >= 1:3.6.27
Requires:	%{name}-libs = %{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin

%description
Btrfs is a new copy on write filesystem for Linux aimed at
implementing advanced features while focusing on fault tolerance,
repair and easy administration.

%description -l pl.UTF-8
Btrfs to nowy system plików dla Linuksa oparty na zasadzie kopiowania
przy zapisie (copy-on-write), którego celem jest zaimplementowanie
zaawansowanych możliwości ze szczególnym naciskiem na odporność na
awarie, naprawę i łatwe administrowanie.

%package libs
Summary:	Shared btrfs library
Summary(pl.UTF-8):	Biblioteka współdzielona btrfs
Group:		Libraries

%description libs
Shared btrfs library.

%description libs -l pl.UTF-8
Biblioteka współdzielona btrfs.

%package devel
Summary:	Header files for btrfs filesystem-specific library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki dla systemu plików btrfs
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
This package contains the header files needed to develop btrfs
filesystem-specific programs.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe potrzebne przy tworzeniu programów
przeznaczonych dla systemu plików btrfs.

%package static
Summary:	Static btrfs filesystem library
Summary(pl.UTF-8):	Statyczna biblioteka dla systemu plików btrfs
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static btrfs filesystem library.

%description static -l pl.UTF-8
Statyczna biblioteka dla systemu plików btrfs.

%package -n libbtrfsutil
Summary:	Library for managing Btrfs filesystems
Summary(pl.UTF-8):	Biblioteka do zarządzania systemami plików Btrfs
License:	LGPL v3
Group:		Libraries

%description -n libbtrfsutil
libbtrfsutil is a library for managing Btrfs filesystems. It is
licensed under the LGPL. libbtrfsutil provides interfaces for a subset
of the operations offered by the btrfs command line utility. It also
has official Python bindings (Python 3 only).

%description -n libbtrfsutil -l pl.UTF-8
libbtrfsutil to biblioteka do zarządzania systemami plików Btrfs. Jest
dostępna na licencji LGPL. Udostępnia interfejsy do podzbioru operacji
oferowanych przez narzędzie linii poleceń btrfs. Ma także oficjalne
wiązania do Pythona (tylko Pythona 3).

%package -n libbtrfsutil-devel
Summary:	Header file for libbtrfsutil library
Summary(pl.UTF-8):	Plik nagłówkowy biblioteki libbtrfsutil
License:	LGPL v3
Group:		Development/Libraries
Requires:	libbtrfsutil = %{version}-%{release}

%description -n libbtrfsutil-devel
Header file for libbtrfsutil library.

%description -n libbtrfsutil-devel -l pl.UTF-8
Plik nagłówkowy biblioteki libbtrfsutil.

%package -n libbtrfsutil-static
Summary:	Static libbtrfsutil library
Summary(pl.UTF-8):	Statyczna biblioteka libbtrfsutil
License:	LGPL v3
Group:		Development/Libraries
Requires:	libbtrfsutil-devel = %{version}-%{release}

%description -n libbtrfsutil-static
Static libbtrfsutil library.

%description -n libbtrfsutil-static -l pl.UTF-8
Statyczna biblioteka libbtrfsutil.

%package -n python3-btrfsutil
Summary:	Python library for managing Btrfs filesystems
Summary(pl.UTF-8):	Biblioteka Pythona do zarządzania systemami plików Btrfs
Group:		Libraries/Python
License:	LGPL v3
Requires:	libbtrfsutil = %{version}-%{release}

%description -n python3-btrfsutil
Python library for managing Btrfs filesystems.

%description -n python3-btrfsutil -l pl.UTF-8
Biblioteka Pythona do zarządzania systemami plików Btrfs.

%prep
%setup -q -n %{name}-v%{version}
%patch0 -p1

%build
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%configure \
	%{!?with_python:--disable-python}
%{__make} \
	V=1

%if %{with tests}
%{__make} test-libbtrfsutil
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_mandir}/man8}
%{__make} install \
	prefix=%{_prefix} \
	bindir=%{_sbindir} \
	mandir=%{_mandir} \
	libdir=%{_libdir} \
	DESTDIR=$RPM_BUILD_ROOT

%if %{with python}
%{__make} install_python \
	prefix=%{_prefix} \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%post	-n libbtrfsutil -p /sbin/ldconfig
%postun	-n libbtrfsutil -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CHANGES README.md
%attr(755,root,root) %{_sbindir}/btrfs
%attr(755,root,root) %{_sbindir}/btrfs-convert
%attr(755,root,root) %{_sbindir}/btrfs-find-root
%attr(755,root,root) %{_sbindir}/btrfs-image
%attr(755,root,root) %{_sbindir}/btrfs-map-logical
%attr(755,root,root) %{_sbindir}/btrfs-select-super
%attr(755,root,root) %{_sbindir}/btrfsck
%attr(755,root,root) %{_sbindir}/btrfstune
%attr(755,root,root) %{_sbindir}/fsck.btrfs
%attr(755,root,root) %{_sbindir}/mkfs.btrfs
/lib/udev/rules.d/64-btrfs-dm.rules
%{_mandir}/man5/btrfs.5*
%{_mandir}/man8/btrfs.8*
%{_mandir}/man8/btrfs-*.8*
%{_mandir}/man8/btrfsck.8*
%{_mandir}/man8/btrfstune.8*
%{_mandir}/man8/fsck.btrfs.8*
%{_mandir}/man8/mkfs.btrfs.8*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libbtrfs.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libbtrfs.so.0

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libbtrfs.so
%{_includedir}/btrfs

%files static
%defattr(644,root,root,755)
%{_libdir}/libbtrfs.a

%files -n libbtrfsutil
%defattr(644,root,root,755)
%doc libbtrfsutil/README.md
%attr(755,root,root) %{_libdir}/libbtrfsutil.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libbtrfsutil.so.1

%files -n libbtrfsutil-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libbtrfsutil.so
%{_includedir}/btrfsutil.h
%{_pkgconfigdir}/libbtrfsutil.pc

%files -n libbtrfsutil-static
%defattr(644,root,root,755)
%{_libdir}/libbtrfsutil.a

%if %{with python}
%files -n python3-btrfsutil
%attr(755,root,root) %{py3_sitedir}/btrfsutil.cpython-*.so
%{py3_sitedir}/btrfsutil-%{version}-py*.egg-info
%endif
%changelog
* Sat May 08 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/btrfs-progs.git;a=log;h=master

* Sat May 08 2021 Jakub Bogusz <qboosh@pld-linux.org> 8a1e432
- updated to 5.11.1

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> d5c13c1
- release 3 (by relup.sh)

* Mon Oct 28 2019 Jakub Bogusz <qboosh@pld-linux.org> a34ee28
- BR: python3-setuptools

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> c4aa91c
- rebuild with python 3.8
- release 2 (by relup.sh)

* Sun Oct 27 2019 Jakub Bogusz <qboosh@pld-linux.org> a3192b0
- updated to 5.3.1

* Mon Jul 29 2019 Jakub Bogusz <qboosh@pld-linux.org> e0bfcc9
- updated to 5.2.1

* Sat Jun 01 2019 Jakub Bogusz <qboosh@pld-linux.org> 31d6d0a
- BR: automake (for aclocal)

* Sat May 18 2019 Adam Gołębiowski <adamg@pld-linux.org> 6fb75e4
- updated to 5.1

* Tue Feb 26 2019 Adam Gołębiowski <adamg@pld-linux.org> 67fefe1
- updated to 4.20.2

* Tue Oct 09 2018 Adam Gołębiowski <adamg@pld-linux.org> 67059df
- updated to 4.17.1

* Thu Jul 19 2018 Jakub Bogusz <qboosh@pld-linux.org> 6d4283b
- updated to 4.17
- updated man patch
- added sh patch (adjust for ksh rejecting variable substitution)
- added python-async patch (adjust Python API for "async" being keyword since Python 3.5)
- added libbtrfsutil* and python3-btrfsutil packages

* Sun Aug 13 2017 Tomasz Pala <gotar@pld-linux.org> 35aaeb3
- upgraded to 4.12

* Sun Jul 31 2016 Jakub Bogusz <qboosh@pld-linux.org> ca4b502
- updated to 4.7

* Thu May 12 2016 Jakub Bogusz <qboosh@pld-linux.org> cf808c4
- updated to 4.5.3

* Wed May 11 2016 Jakub Bogusz <qboosh@pld-linux.org> c5d4b49
- updated to 4.5.2

* Fri Apr 01 2016 Jakub Bogusz <qboosh@pld-linux.org> 8350799
- updated to 4.5.1
- updated man patch

* Sun Mar 06 2016 Jakub Bogusz <qboosh@pld-linux.org> eafe254
- updated to 4.4.1

* Tue Jan 26 2016 Jakub Bogusz <qboosh@pld-linux.org> e7b8bca
- updated to 4.4

* Sun Nov 08 2015 Jakub Bogusz <qboosh@pld-linux.org> d3f74c4
- updated to 4.3

* Mon Oct 05 2015 Jakub Bogusz <qboosh@pld-linux.org> 8fa447e
- updated to 4.2.2

